//############################################################################

//  Author:	Sharjith Nair
//  Email:	sharjith_ssn@hotmail.com

// Program:	OpenGL, C++ MFC StereoLithography Data File Viewer Application

//							Important Notice:

//	This Idea and the Application is Copyright(c) Sharjith Nair 2002, 2003.
//	You can freely use it as long as you credit me for it.

//	No guarantee/warranty is given on this app and I will not be responsible 
//	for any damage to you, your property or any other person from using it.
//	USE IT ON YOUR OWN RISK.

//	Thankyou
//	Sharjith Nair.

//#############################################################################

// BoundingBox.h: interface for the CBoundingBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BOUNDINGBOX_H__098639F6_5719_4B89_8478_0A0F51851F73__INCLUDED_)
#define AFX_BOUNDINGBOX_H__098639F6_5719_4B89_8478_0A0F51851F73__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPoint3D;

class CBoundingBox  
{
public:
	CBoundingBox();
	CBoundingBox(const double&, const double&, const double&, const double&, const double&, const double&);
	virtual ~CBoundingBox();
	void SetLimits(const double&, const double&, const double&, const double&, const double&, const double&);
	double XMax() const { return itsXMax; }
	double XMin() const { return itsXMin; }
	double YMax() const { return itsYMax; }
	double YMin() const { return itsYMin; }
	double ZMax() const { return itsZMax; }
	double ZMin() const { return itsZMin; }
	CPoint3D Center() const;
	double BoundingRadius() const;
	bool Contains(const CPoint3D& P) const;
	void AddBox(const CBoundingBox&);
private:
	double itsXMax;
	double itsXMin;
	double itsYMax;
	double itsYMin;
	double itsZMax;
	double itsZMin;
};

#endif // !defined(AFX_BOUNDINGBOX_H__098639F6_5719_4B89_8478_0A0F51851F73__INCLUDED_)
