//############################################################################

//  Author:	Sharjith Nair
//  Email:	sharjith_ssn@hotmail.com

// Program:	OpenGL, C++ MFC StereoLithography Data File Viewer Application

//							Important Notice:

//	This Idea and the Application is Copyright(c) Sharjith Nair 2002, 2003.
//	You can freely use it as long as you credit me for it.

//	No guarantee/warranty is given on this app and I will not be responsible 
//	for any damage to you, your property or any other person from using it.
//	USE IT ON YOUR OWN RISK.

//	Thankyou
//	Sharjith Nair.

//#############################################################################

// GLTypeEnums.h: Type Enumerations For Graphics.
//
//////////////////////////////////////////////////////////////////////
#ifndef __GLTYPEENUMS_H__
#define __GLTYPEENUMS_H__

//Every CGLObject created in the context must have a unique id;
enum GLObjectType { GLCURVE = 123456, GLFONT = 234561, 
					GLPLANE = 345612, GLPOINT = 456123, 
					GLSURFACE = 561234, GLTRIHEDRON = 612345, 
					GLAXIS = 876543, GLONEAXIS = 765432, GLUSERDEF = 875643};

//Somehow I dont like the GL_POINTS primitive of OpenGL
//So creating some markers for point display
enum GLPointMarker { MARKER_POINT, MARKER_PLUS, MARKER_CROSS, MARKER_STAR, MARKER_CIRCLE };

enum GLLineStyle { LINE_SOLID, LINE_DOTTED, LINE_DASHED, LINE_DASHDOTTED };

enum GLDisplayMode { GLSHADED, GLWIREFRAME, GLHLREMOVED };

// Some Standard Materials
// P_ prefix denotes Polished
enum GLMaterial {DEFAULT,ALUMINIUM, BRASS, BRONZE, P_BRONZE, CHROME, COPPER, P_COPPER, GOLD, P_GOLD,
				PEWTER, SILVER, P_SILVER, STEEL,
				EMERALD, JADE, OBSIDIAN, PEARL, RUBY, TURQUOISE,
				PLASTIC, RUBBER, NONE};


#endif