//############################################################################

//  Author:	Sharjith Nair
//  Email:	sharjith_ssn@hotmail.com

// Program:	OpenGL, C++ MFC StereoLithography Data File Viewer Application

//							Important Notice:

//	This Idea and the Application is Copyright(c) Sharjith Nair 2002, 2003.
//	You can freely use it as long as you credit me for it.

//	No guarantee/warranty is given on this app and I will not be responsible 
//	for any damage to you, your property or any other person from using it.
//	USE IT ON YOUR OWN RISK.

//	Thankyou
//	Sharjith Nair.

//#############################################################################

// Line3D.h: interface for the CLine3D class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LINE3D_H__5EAE9E77_1D1A_426B_A0A5_BF82B65CA45B__INCLUDED_)
#define AFX_LINE3D_H__5EAE9E77_1D1A_426B_A0A5_BF82B65CA45B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Curve.h"
#include "Point3D.h"
#include "Vector3D.h"
#include "OneAxis.h"

class CPoint3D;
class CVector3D;
class COneAxis;

class CLine3D : public CCurve  
{
public:
	CLine3D();
	CLine3D(const CPoint3D&, const CPoint3D&);
	CLine3D(const CPoint3D&, const CVector3D&);
	virtual ~CLine3D();
	virtual void Reverse();
	virtual CPoint3D PointAtPara(const double& par);
	virtual double FirstParameter() const;
	virtual double LastParameter() const;
	virtual bool IsClosed() const;
	bool operator == (const CLine3D& L) const;
	void operator = (const CLine3D& L);
	CVector3D Direction() const;
	COneAxis GetLocation() const;
	CVector3D NormalThrough(const CPoint3D&);
	double Distance(const CPoint3D&);
	CPoint3D StartPoint() const;
	CPoint3D EndPoint() const;
	virtual CCurve* Copy() const;
	virtual void Translate(const COneAxis&, const double&);
	virtual void Translate(double dx, double dy, double dz);
	virtual void Translate(const CVector3D&);
	virtual void Translate(const CPoint3D&, const CPoint3D&);
	virtual void Rotate(const COneAxis&, double);
	virtual void Scale(const CPoint3D&, double);
	virtual void Mirror(const CPoint3D&);
	virtual void Mirror(const COneAxis&);
	virtual void Mirror(const CPlane&);
private:
	CPoint3D startPoint;
	CPoint3D endPoint;
	COneAxis itsLocation;
};

#endif // !defined(AFX_LINE3D_H__5EAE9E77_1D1A_426B_A0A5_BF82B65CA45B__INCLUDED_)
