//############################################################################

//  Author:	Sharjith Nair
//  Email:	sharjith_ssn@hotmail.com

// Program:	OpenGL, C++ MFC StereoLithography Data File Viewer Application

//							Important Notice:

//	This Idea and the Application is Copyright(c) Sharjith Nair 2002, 2003.
//	You can freely use it as long as you credit me for it.

//	No guarantee/warranty is given on this app and I will not be responsible 
//	for any damage to you, your property or any other person from using it.
//	USE IT ON YOUR OWN RISK.

//	Thankyou
//	Sharjith Nair.

//#############################################################################

// ListOfCGLObject.h: interface for the CListOfCGLObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LISTOFCGLOBJECT_H__F3668FBC_D69E_4C34_839E_29D4B3544040__INCLUDED_)
#define AFX_LISTOFCGLOBJECT_H__F3668FBC_D69E_4C34_839E_29D4B3544040__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ListNodeOfCGLObject.h"

class CGLObject;
class CListIteratorOfListOfCGLObject;

class CListOfCGLObject
{
	friend class CListIteratorOfListOfCGLObject;
public:
	CListOfCGLObject();
	virtual ~CListOfCGLObject();
	void Append(CGLObject*);
	void Prepend(CGLObject*);
	CGLObject* First() const;
	CGLObject* Last() const;
	CListNodeOfCGLObject* Previous(const CGLObject*);
	CGLObject* Remove(const CGLObject*);
	bool IsEmpty() const;
	void Clear();
private:
	CListNodeOfCGLObject* firstPtr;
	CListNodeOfCGLObject* lastPtr;
private:
	CListNodeOfCGLObject* NewNode(CGLObject*);
};

#endif // !defined(AFX_LISTOFCGLOBJECT_H__F3668FBC_D69E_4C34_839E_29D4B3544040__INCLUDED_)
