//############################################################################

//  Author:	Sharjith Nair
//  Email:	sharjith_ssn@hotmail.com

// Program:	OpenGL, C++ MFC StereoLithography Data File Viewer Application

//							Important Notice:

//	This Idea and the Application is Copyright(c) Sharjith Nair 2002, 2003.
//	You can freely use it as long as you credit me for it.

//	No guarantee/warranty is given on this app and I will not be responsible 
//	for any damage to you, your property or any other person from using it.
//	USE IT ON YOUR OWN RISK.

//	Thankyou
//	Sharjith Nair.

//#############################################################################

// OneAxis.h: interface for the COneAxis class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ONEAXIS_H__78EA474B_0A0E_4FAC_9C7F_F2B760C34538__INCLUDED_)
#define AFX_ONEAXIS_H__78EA474B_0A0E_4FAC_9C7F_F2B760C34538__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Geometry.h"
#include "Point3D.h"
#include "Vector3D.h"

class CPoint3D;
class CVector3D;

class COneAxis : public CGeometry  
{
public:
	COneAxis();
	COneAxis(const CPoint3D& Pos, const CVector3D& Dir);
	~COneAxis();
	void SetPosition(const CPoint3D& P);
	void SetPosition(double x, double y, double z);
	void SetDirection(const CVector3D& D);
	void SetDirection(double dx, double dy, double dz);
	CPoint3D GetPosition() const;
	CVector3D GetOrigin() const;
	CVector3D GetDirection() const;
	bool operator == (const COneAxis&) const;
	virtual void Translate(const COneAxis&, const double&);
	virtual void Translate(double dx, double dy, double dz);
	virtual void Translate(const CVector3D&);
	virtual void Translate(const CPoint3D&, const CPoint3D&);
	virtual void Rotate(const COneAxis&, double);
	virtual void Scale(const CPoint3D&, double);
	virtual void Mirror(const CPoint3D&);
	virtual void Mirror(const COneAxis&);
	virtual void Mirror(const CPlane&);
	static COneAxis OX();
	static COneAxis OY();
	static COneAxis OZ();
private:
	CPoint3D Position;
	CVector3D Origin;
	CVector3D Direction;
};

#endif // !defined(AFX_ONEAXIS_H__78EA474B_0A0E_4FAC_9C7F_F2B760C34538__INCLUDED_)
