//############################################################################

//  Author:	Sharjith Nair
//  Email:	sharjith_ssn@hotmail.com

// Program:	OpenGL, C++ MFC StereoLithography Data File Viewer Application

//							Important Notice:

//	This Idea and the Application is Copyright(c) Sharjith Nair 2002, 2003.
//	You can freely use it as long as you credit me for it.

//	No guarantee/warranty is given on this app and I will not be responsible 
//	for any damage to you, your property or any other person from using it.
//	USE IT ON YOUR OWN RISK.

//	Thankyou
//	Sharjith Nair.

//#############################################################################

// StlObject.h: interface for the CStLObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STLOBJECT_H__0B30ABE7_430E_41A7_80B1_41426F4C6C87__INCLUDED_)
#define AFX_STLOBJECT_H__0B30ABE7_430E_41A7_80B1_41426F4C6C87__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GLObject.h"
#include "StLReader.h"
#include "ListOfCPoint3D.h"
#include "ListIteratorOfListOfCPoint3D.h"

class CStLObject : public CGLObject  
{
public:
	CStLObject(){}
	CStLObject(CStLReader*);
	virtual ~CStLObject();
	virtual CGLObject* Copy() const;
	virtual void DefineDisplay();
	virtual void Display(const GLDisplayMode& = GLWIREFRAME);
	virtual void Hilight(const GLDisplayMode&);
	virtual void SetColor(const GLubyte&, const GLubyte&, const GLubyte&);
	virtual void GetColor(GLubyte*) const;
private:
	void DrawWired();
	void DrawShaded();
	void ComputePoints();
	void ComputeBoundLimits();
private:
	CStLReader *myReader;
	CListOfCPoint3D* pointList;
};

#endif // !defined(AFX_STLOBJECT_H__0B30ABE7_430E_41A7_80B1_41426F4C6C87__INCLUDED_)
